/*
 * 	crypto_user.h
 *
 * Copyright (c) 2004 Evgeniy Polyakov <johnpol@2ka.mipt.ru>
 * 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

#ifndef __CRYPTO_USER_H
#define __CRYPTO_USER_H

#define MAX_DATA_SIZE	3
#define ALIGN_DATA_SIZE(size)	((size + PAGE_SIZE - 1) & ~(PAGE_SIZE - 1))

enum crypto_user_data_types {
	CRYPTO_USER_DATA_SRC = 0,
	CRYPTO_USER_DATA_DST,
	CRYPTO_USER_DATA_KEY,
	CRYPTO_USER_DATA_IV,
};

struct crypto_user_data
{
	__u16		data_size;
	__u16		data_type;
};


#ifdef __KERNEL__

int crypto_user_alloc_crypto_data(struct crypto_data *data, int src_size, int dst_size, int key_size, int iv_size);
void crypto_user_free_crypto_data(struct crypto_data *data);
void crypto_user_fill_sg(void *ptr, u16 size, struct scatterlist *sg);
struct scatterlist *crypto_user_get_sg(struct crypto_user_data *ud, struct crypto_data *data);
int crypto_user_fill_sg_data(struct crypto_user_data *ud, struct crypto_data *data, void *ptr);

#endif /* __KERNEL__ */
#endif /* __CRYPTO_USER_H */
