/*
 * 	crypto_user_direct.h
 *
 * Copyright (c) 2004 Evgeniy Polyakov <johnpol@2ka.mipt.ru>
 * 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

#ifndef __CRYPTO_USER_DIRECT_H
#define __CRYPTO_USER_DIRECT_H

struct crypto_user_direct
{
	__u64			src;
	__u32			src_size;
	__u64			dst;
	__u32			dst_size;
	
	__u16 			operation;
	__u16 			type;
	__u16 			mode;
	__u16 			priority;

	int			pid;

	int			key_size;
	int			iv_size;

	__u8			data[0];
};

#ifdef __KERNEL__

#include <linux/sched.h>
#include <linux/mm.h>
#include <linux/pagemap.h>

struct crypto_user_direct_kern
{
	struct list_head	entry;

	u32			seq;
	u32			ack;

	struct crypto_user_direct	usr;
	u8			*key;
	u8			*iv;

	int			snum, dnum;
	struct page		**sp, **dp;
	struct vm_area_struct 	**svma, **dvma;
	struct mm_struct 	*mm;
};

int crypto_user_direct_init(void);
void crypto_user_direct_fini(void);
int crypto_user_direct_add_request(u32 seq, u32 ack, struct crypto_user_direct *usr);

#endif /* __KERNEL__ */

#endif /* __CRYPTO_USER_DIRECT_H */
